<template>
  <ob-form
    class="contract-direction-form"
    :form-data="formData"
    :form-model="formModel"
    :is-read-only="!isDraft"
    data-qa="directionForm"
    @submit="onSubmitHandler"
    :ok-text="isNew ? 'Добавить' : 'Сохранить'"
    cancel-text="Отменить"
  >
    <p class="mb30">
      {{ service.serviceTitle }}
    </p>
    <template v-if="isNew">
      <div
        v-for="(point, index) in formData.points || []"
        :key="point.uuid"
        class="location-input"
      >
        <ObAddressInput
          display-exp="russian_address"
          title="Адрес"
          placeholder="Укажите локацию или точный адрес"
          :value="point"
          :map-id="'multistop-point-' + index"
          @input="onSetLocation(point, $event)"
          @on-change-address="onSetLocation(point, $event)"
        />
        <button
          v-if="formData.points && formData.points.length > 2"
          class="location-input__remove"
          @click="removePoint(index)"
        >
          <i class="icon close"/>
        </button>
      </div>
    </template>
    <button
      class="add-point"
      @click="addPoint"
    >
      <i class="icon plus" />
      <span>Добавить точку</span>
    </button>
    <div
      v-if="isVatPayer"
      class="nds-row mb30"
    >
      <i class="icon alert" />
      <span>{{ service.isVatInclude ? 'Все тарифы включают в себя НДС' : 'Тарифы указываются без учета НДС' }} {{ service.vatRate || 20 }}%</span>
    </div>
    <div class="row">
      <div class="col-xs-4">
        <div class="sub-title">Тариф услуги:</div>
        <ObInput
          :value="getTariff('tariff')"
          label="Тариф"
          sub-title="₽"
          placeholder="Укажите"
          type="money:2"
          :readonly="!isDraft"
          data-qa="tariff"
          property="tariff"
          @input="onInputTariff('tariff', $event)"
        />
      </div>
      <div class="col-xs-4">
        <div class="sub-title">Тариф допточки:</div>
        <ObInput
          :value="getTariff('extraMileageTariff')"
          label="Тариф"
          sub-title="₽"
          placeholder="Укажите"
          type="money:2"
          :readonly="!isDraft"
          data-qa="extraMileageTariff"
          @input="onInputTariff('extraMileageTariff', $event)"
        />
      </div>
      <div class="col-xs-4">
        <div class="sub-title">Тариф допробега:</div>
        <ObInput
          :value="getTariff('extraPointTariff')"
          label="Тариф"
          sub-title="₽/км"
          placeholder="Укажите"
          type="money:2"
          :readonly="!isDraft"
          data-qa="extraPointTariff"
          @input="onInputTariff('extraPointTariff', $event)"
        />
      </div>
    </div>
  </ob-form>
</template>

<script>
  import { mapState, mapGetters } from 'vuex'
  import api from '@/api'
  import FormValidationMixin from 'common-components/src/obComponents/obForm/FormValidationMixin'
  import models from '@/models'
  import cloneDeep from 'clone-deep'
  import ObForm from 'common-components/src/obComponents/obForm'
  import ObInput from 'common-components/src/obComponents/obInput'
  import ObAddressInput from 'common-components/src/obComponents/obAddressInput'
  import { uuid } from 'vue-uuid'
  import debounce from "debounce";

  export default {
    name: 'ContractDirectionMultistopForm',
    components: {
      ObAddressInput,
      ObInput,
      ObForm
    },
    mixins: [
      FormValidationMixin
    ],
    data () {
      return {
        api,
        dropdownMenu: [
          {
            label: 'Отключить направление',
            method: this.disableDirection
          }
        ]
      }
    },
    computed: {
      ...mapState({
        service: state => state.contract.editedService
      }),
      ...mapGetters({
        isDraft: 'contract/isDraft',
        isVatPayer: 'contract/isDoerVatPayer'
      }),
      formModel () {
        const { vatType = 'NO_VAT', vatRate = 0 } = this.dataSource || {}

        if (this.isNew) {
          return models.contract.directionsMultistop({ isVatPayer: this.isVatPayer })
        } else {
          return models.contract.directionsMultistopEdit({
            isVatPayer: this.isVatPayer,
            vatType,
            vatRate
          })
        }
      },
      isNew () {
        return !this.dataSource?.directionUuid
      }
    },
    methods: {
      onSubmitHandler () {
        let data = cloneDeep(this.formData)
        data.points = data.points.map((point) => {
          Object.keys(point).forEach((key) => {
            if (!point[key] && typeof point[key] !== 'boolean') {
              delete point[key]
            }
          })

          return point
        })
        this.$emit('submit', {formData: data, model: this.formModel})
      },
      disableDirection () {
        this.$emit('on-disable-direction', { uuid: this.formData.directionUuid })
      },
      onSetLocation (data, location) {
        data.locationUuid = null
        data.address = ''
        data.coordinates = null

        if (!location) {
          return false
        }

        data.isLocation = Boolean(location.isLocation)
        data.locationUuid = location.locationUuid
        data.address = location.label
        data.coordinates = location.coordinates
      },
      addPoint () {
        this.formData.points.push({
          locationUuid: null,
          address: '',
          uuid: uuid.v4()
        })
      },
      removePoint (index) {
        this.formData.points.splice(index, 1)
      },
      async onInputTariff (key, value) {
        this.formData[key][this.service.isVatInclude ? 'priceWithVat' : 'priceWithoutVat'] = value
        await this.calcTariff()
      },
      calcTariff: debounce(async function() {
        let targetKeys = [ 'tariff', 'extraMileageTariff', 'extraPointTariff' ].filter(targetKey => {
          return this.formData[targetKey]?.[this.service.isVatInclude ? 'priceWithVat' : 'priceWithoutVat'] !== undefined
        })

        let postData = targetKeys.map(targetKey => {
          const priceObject = this.service.isVatInclude
            ? { priceWithVat: this.formData[targetKey]?.priceWithVat || '' }
            : { priceWithoutVat: this.formData[targetKey]?.priceWithoutVat || '' }
          return {
            vatRate: this.formData.vatRate,
            quantity: 1,
            ...priceObject
          }
        })

        if (this.formData.vatRate) {
          let { itemsList } = await api.orderProcess.vatCalculation({ list: postData })

          targetKeys.forEach((targetKey, index) => {
            const { priceWithVat = '', priceWithoutVat = '', vatValue = '' } = itemsList[index] || {}
            this.formData[targetKey].priceWithVat = priceWithVat
            this.formData[targetKey].priceWithoutVat = priceWithoutVat
            this.formData[targetKey].vatPrice = vatValue
          })
        } else {
          targetKeys.forEach(targetKey => {
            this.formData[targetKey].priceWithVat = this.formData[targetKey]?.priceWithoutVat
            this.formData[targetKey].vatPrice = 0
          })
        }
      }, 500),
      getTariff (key) {
        return this.service.isVatInclude ? this.formData[key]?.priceWithVat : this.formData[key]?.priceWithoutVat
      }
    }
  }
</script>

<style lang='scss' scoped>
  @import '~common-components/src/static/css/mixins';

  .contract-direction-form {
    .main-title {
      @include font-mixin(20px, 28px, 600, $color-text-base, 0.4px);
    }

    .sub-title {
      margin-bottom: 10px;
      @include font-mixin(16px, 24px, 600, $color-text-base, 0.4px);
    }

    .location-input {
      display: flex;
      align-items: center;
      margin-bottom: 20px;
      &::v-deep {
        .ob-address-input {
          flex-grow: 2;
        }
      }
      &__remove {
        margin-left: 18px;
        font-size: 20px;
        color: $color-grey-span;
        border: none;
        background-color: transparent;
        outline: none;
        cursor: pointer;
        &:hover {
          opacity: 0.8;
        }
      }
    }

    .add-point {
      display: flex;
      align-items: center;
      margin-top: 30px;
      margin-bottom: 30px;
      border: none;
      background-color: transparent;
      outline: none;
      cursor: pointer;
      &:hover {
        opacity: 0.8;
      }
      i {
        margin-right: 6px;
        font-size: 16px;
        color: $color-grey-span;
      }
      span {
        @include font-mixin(14px, 16px, 400, $color-blue-navy-blue, 0.2px);
      }
    }

    .nds-row {
      width: 100%;
      display: flex;
      align-items: center;
      padding: 20px;
      background-color: $color-white-lilac;
      .icon {
        font-size: 24px;
        color: $color-blue-navy-blue;
      }
      span {
        padding-left: 20px;
        font-size: 14px;
        line-height: 20px;
        color: $color-text-base;
      }
    }
  }
</style>

<style lang="scss">
  .contract-direction-form {
    .mt20 {
      margin-top: 20px!important;
    }

    .mb20 {
      margin-bottom: 20px !important;
    }

    .mb15 {
      margin-bottom: 15px !important;
    }

    .mb30 {
      margin-bottom: 30px!important;
    }

    .checkbox-input {
      display: flex;
      justify-content: flex-start;
      align-items: center;

      .ob-checkbox-container {
        flex-shrink: 0;
        margin-left: 20px;
      }
    }
  }
</style>
